--[[
	ExtremaRatioAssistant: gestisci gli inviti ai raid per gli Extrema Ratio
	anche noto come FIGOLAS
	
	Fantastico
	Invitatore di
	Gildani
	Ottimizzato per
	L'
	Autoinvito
	Sicuro
	
	by Stormbeard - Pozzo Dell'Eternità, gilda Extrema Ratio
]]---
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceTimer-3.0","AceEvent-3.0")
_G[addonName] = ERA
local ACEGUI

--***************************************
--<UPVALUE>
local pairs = pairs
local ipairs = ipairs
local print = print
local unpack = unpack
local type = type
local next = next
local tinsert = table.insert
local tsort = table.sort
local wipe = wipe
local format = string.format
local match = string.match
local find = string.find
local lower = string.lower
local upper = string.upper
local gsub = gsub
local gmatch = string.gmatch
local setmetatable = setmetatable
local select = select
local IsInRaid = IsInRaid
local IsInGroup = IsInGroup
local UnitIsGroupLeader = UnitIsGroupLeader
local UnitInParty = UnitInParty
local UnitInRaid = UnitInRaid
local InviteUnit = InviteUnit
local UnitPlayerOrPetInRaid = UnitPlayerOrPetInRaid
local SetLootMethod = SetLootMethod
local PromoteToAssistant = PromoteToAssistant
local DemoteAssistant = DemoteAssistant
local UnitGUID = UnitGUID
local GetNumGroupMembers = GetNumGroupMembers
local UnitIsRaidOfficer = UnitIsRaidOfficer
local UnitIsUnit = UnitIsUnit
local GetUnitName = GetUnitName
local UnitName = UnitName
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local GetPartyAssignment = GetPartyAssignment
local CreateFrame = CreateFrame
local ConvertToRaid = ConvertToRaid
local SendChatMessage = SendChatMessage
local GetNumGuildMembers = GetNumGuildMembers
local GetGuildRosterInfo = GetGuildRosterInfo
local GuildRoster = GuildRoster
local CanGuildPromote = CanGuildPromote
local CanGuildDemote = CanGuildDemote
local SetGuildMemberRank = SetGuildMemberRank
local UninviteUnit = UninviteUnit
local GameTooltip = GameTooltip
local UnitAffectingCombat = UnitAffectingCombat

local _


--</UPVALUE>

--***************************************

--<VARIABILI>
local db = {}
local on = L["Autoinvito \|cFF00FF00ON\|r"]
local off =  L["Autoinvito \|cFFFF0000OFF\|r"]
local ON = L["\|cFF00FF00ON\|r"]
local OFF = L["\|cFFFF0000OFF\|r"]
local status = { --una maniera contorta per usare una stringa...
	--"accettati","pendenti","potenziali",
	["accettato"]="accettato",
	["invitato"]="invitato",
	["potenziale"]="potenziale",
	["imbucato"] = "imbucato"
}
local aspetto= {
	--pendenti = [[|TInterface\RaidFrame\ReadyCheck-Waiting|t|cFFFFFF00%s|r]],--gialli con ? 
	--potenziali = [[|TInterface\RaidFrame\ReadyCheck-Waiting|t%s]],--bianchi con ? davanti
	--accettati = [[|TInterface\RaidFrame\ReadyCheck-Ready|t|cFF00FF00%s|r]],---verdi con baffo davanti
	--imbucati = [[|cFF0000FF%s|r]],--? blu
	--rifiutati = [[|TInterface\RaidFrame\ReadyCheck-NotReady|t|cFFFF0000%s|r]],--rossi con x davanti
	invitato = {--bianco
		r = 1,
		g = 1,
		b = 1,
		icona = [[Interface\RaidFrame\ReadyCheck-Waiting]],
		txt = "%s",
		tooltip = L["Invitato"],
		action = "",
		
	},	
	--potenziale = è il default, si fa riferimento a __index sotto
	accettato = {--verde
		r = 0,
		g = 1,
		b = 0,
		icona = [[Interface\RaidFrame\ReadyCheck-Ready]],
		txt = [[|cFF00FF00%s|r]],---verdi con baffo davanti
		tooltip = L["In gruppo"],
		action = "",
	},
	imbucato = {
		r = 0.41,
		g = 0.80,
		b = 0.94,
		icona = [[Interface\RaidFrame\ReadyCheck-Ready]],
		txt = [[|cFF69CCF0%s|r]],
		tooltip =L["In gruppo, non confermato"],
		action = L["Clicca per rimuovere dal gruppo"],
	},--? azzurro
	
	--rifiutati = [[|TInterface\RaidFrame\ReadyCheck-NotReady|t|cFFFF0000%s|r]],--rossi con x davanti
}
setmetatable(aspetto, {__index = function(t,k) 
         t[k] = {--rosso potenziale
            r = 1,--255,
            g = 0,--0,
            b = 0,--0,
            icona = [[Interface\RaidFrame\ReadyCheck-Waiting]],
            txt = [[|cFFFF0000%s|r]],
			tooltip = L["confermato"],
			action = L["Clicca per invitare"],
         }
         return t[k]
      end,
})
	
local DEFAULTDB = {
	profile={
		opzioni = {
			--monitor = nil,
			SetMT = true,
			EPGP = true,
			
			EPGPUICfg = {
				['**'] = {
					["txt"] = L["Pulsante"],
					--["recurring"] = "no",
					["awardAmount"] = 0,
					["recurringAmount"] = 0,
					["reason"] = "raid",
					--["decay"] = false,
					--["award"] = false,
					["recurringTime"] = 5,
				},--default for every keys			
			},
		},				
		raid = {
			roster = {
			},
			drafted = {
			},
			list = "",
		},
		whisper = {
		   kwordList = "raid",--le parole da usare per autoinvitarsi
		   --casesensitive =nil -- inutile
		   safe = true, --blocca gli inviti durante i boss
		   startMsg = L["Autoinvitatevi scrivendomi raid."],--messaggio che appare quando si preme whisper
		   blacklist = {},--lista di persone non gradite
		   --minrankname = nil, --non inizializzato
		   guildOnly = true,
		   annuncia = true,
		   --on = nil, 
			--alwaysOn = nil,
			--maxLvlOnly = true,
			--minRank = nil,
			--minRankLvl = nil,
		},
		promozione = {
			--attiva, -- per sapere se la promozione e' attiva, non lo inizializzo
			--["up"] ,--grado per la promozione		
			--["upName"] , --nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
			--["downName"] ,--nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
			--["down"] ,--grado per la retrocessione
			MLooters = "",--list ML			
			assist="", --lista assist
			forzaLM = true, --forza l'uso del ML
			lootMethod="master",
			tankAssist = true,
			ultraPromossi = {}, --lista di quelli promossi che in origine avevano un grado inferiore a quello del grado di retrocessione
		},	
		assistMonitor = {
			focus = {},
			target = {},
		},
		tutorial ={},
	},
}
--</VARIABILI>
--<UTILITY>
--works as pair but sorting keys

local function pairsByKeys (t, criterio)
      local sorted = {}
      for n in pairs(t) do tinsert(sorted, n) end
      tsort(sorted, criterio)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if sorted[i] == nil then return nil
        else return sorted[i], t[sorted[i]]
        end
      end
      return iter
end

ERA.pairsByKeys = pairsByKeys
	
function copytable(obj, seen)
  if type(obj) ~= 'table' then return obj end
  if seen and seen[obj] then return seen[obj] end
  local s = seen or {}
  local res = setmetatable({}, getmetatable(obj))
  s[obj] = res
  for k, v in pairs(obj) do res[copytable(k, s)] = copytable(v, s) end
  return res
end

function ERA:InRaid(unit)
	return UnitPlayerOrPetInRaid(unit) and find(UnitGUID(unit) or "", "Player")
end

--i maledetti nomi dei pg servono a volte con server a volte senza
function ERA:GetName(name,returnserver)
	local n = name
	if not returnserver then
		n = match(n, "([^-]+)") --senza il server
	else
		local s
		n, s = match(n, "([^-]+)-*([^-]*)")
		s = s =="" and self.PGRealm or s		
		n = format("%s-%s",n,s)
		n = gsub(n,"%s","")
	end	
	 return n or ""
end

function ERA:IsGrouped()
	local where = IsInGroup() and "party" or nil
	where = IsInRaid() and "raid" or where
	return where
end

--wrapper per GetGuildRosterInfo che riporta valori da 0 (guildmaster) a x mentre ogni altra funzione di gilda si usano valori da 1 a x -_-
function ERA:GetGuildRosterInfo(i)
	local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
	rankIndex = rankIndex and rankIndex+1 or nil
	return fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation
end

function ERA:Upper1(txt)
   return gsub(txt, "^%l", upper)
end

function ERA:GetTexture(name)
   return format([[Interface\AddOns\%s\Textures\%s]],addonName,name)
end

--**************************
local GetReturn = {
	[0] = function(a) return a end,
	[1] = function(a,b) return a[b] end,
	[2] = function(a,b,c) return a[b][c] end,
	[3] = function(a,b,c,d) return a[b][c][d] end,
	[4] = function(a,b,c,d,e) return a[b][c][d][e] end,
	[5] = function(a,b,c,d,e,f) return a[b][c][d][e][f] end,
}

local SetReturn = {
	[0] = function(a,val) a = val end,
	[1] = function(a,b,val) a[b] = val end,
	[2] = function(a,b,c,val) a[b][c] = val end,
	[3] = function(a,b,c,d,val) a[b][c][d] = val end,
	[4] = function(a,b,c,d,e,val) a[b][c][d][e] = val end,
	[5] = function(a,b,c,d,e,f,val) a[b][c][d][e][f] = val end,
}

--shortcuts
function ERA:DB()
	return ERA.db.profile
end

function ERA:Getroster(...)--(var)
	return GetReturn[select("#",...)](ERA.db.profile.raid.roster,...)
end

function ERA:Setroster(var, val)
	ERA._tmpRef = ERA:Getroster()
	ERA._tmpRef[var] = val
end

function ERA:Getdrafted(...)--(var)	
	return GetReturn[select("#",...)](ERA.db.profile.raid.drafted,...)
end

function ERA:Setdrafted(var, val)
	ERA._tmpRef = ERA:Getdrafted()
	ERA._tmpRef[var] = val
end

function ERA:Getwhisper(...)--(var)	
	return GetReturn[select("#",...)](ERA.db.profile.whisper,...)
end

function ERA:Setwhisper(var, val)
	ERA._tmpRef = ERA:Getwhisper()
	ERA._tmpRef[var] = val
end

function ERA:Getblacklist(...)--(var)	
	return GetReturn[select("#",...)](ERA.db.profile.whisper.blacklist,...)
end

function ERA:Setblacklist(var, val)
	ERA._tmpRef = ERA:Getblacklist()	
	ERA._tmpRef[var] = val
end

function ERA:Gettutorial(...)
	return GetReturn[select("#",...)](ERA.db.profile.tutorial,...)
end

function ERA:Settutorial(var, val)
	ERA._tmpRef = ERA:Gettutorial()	
	ERA._tmpRef[var] = val
end

function ERA:Getpromozione(...)--(var)	
	return GetReturn[select("#",...)](ERA.db.profile.promozione,...)
end

function ERA:Setpromozione(var, val)
	ERA._tmpRef = ERA:Getpromozione()
	ERA._tmpRef[var] = val
end

function ERA:Getopzioni(...)--(var)	
	return GetReturn[select("#",...)](ERA.db.profile.opzioni,...)
end

function ERA:Setopzioni(var, val)
	ERA._tmpRef = ERA:Getopzioni()	
	ERA._tmpRef[var] = val
end

function ERA:GetEPGPUICfg(...)--(var)	 	 
	 return GetReturn[select("#",...)+1](ERA:Getopzioni(),"EPGPUICfg",...)
end

function ERA:SetEPGPUICfg(var, val)
	ERA._tmpRef = ERA:GetEPGPUICfg()	
	ERA._tmpRef[var] = val
end

function ERA:NewEPGPUICfg()	
	ERA.db.profile.opzioni.EPGPUICfg = {}
end

function ERA:GetEPGPBtn(n)
	n = type(n)=="number" and "btn"..n or n
	return ERA:GetEPGPUICfg(n)
end

function ERA:SetEPGPBtn(n, ref)
	n = type(n)=="number" and "btn"..n or n
	ERA:SetEPGPUICfg(n, ref)
end

function ERA:GetEPGPBtnVal(n, val)
	n = type(n)=="number" and "btn"..n or n
	ERA._tmpRef = ERA:GetEPGPBtn(n)
	return ERA._tmpRef[val]
end

function ERA:SetEPGPBtnVal(n, var, val)
	n = type(n)=="number" and "btn"..n or n
	ERA._tmpRef = ERA:GetEPGPBtn(n)
	ERA._tmpRef[var] = val
end

function ERA:Get(short, ...)--non utilizzabile per EPGPBtn ed EPGPBtnVal (cmq accessibili da EPGPUICfg(btn) ed  EPGPUICfg(btn,val))
	return GetReturn[select("#",...)](ERA["Get"..short](this),...)
end

function ERA:Set(short, ...)--non utilizzabile per EPGPBtn ed EPGPBtnVal (cmq accessibili da EPGPUICfg(btn) ed  EPGPUICfg(btn,val))
	ERA["Set"..short](this, var, val)
	--SetReturn[select("#",...)]((ERA["Get"..short](this),...))
end

function ERA:SetDbTable(name, ref)
	ERA.db.profile[name] = ref
end

--************************--



--rimuove il singolo dai draft (applicato al pulsante)
function ERA:RemoveFromDrafted(info)
	ERA:Setdrafted(info[#info],nil)
	ERA.drafted[info[#info]] = nil
	ERA.totaldraft = ERA.totaldraft - 1
	ERA:SortView(ERA.drafted)
	ERA:AggiornaMonitor()
end

--aggiunge ai draft
function ERA:AddToDrafted(n)	
	ERA:Setdrafted(n,n)
	ERA.drafted[n] = setmetatable({},{ __index = {
		order = 10,
		type = "execute",		
		func = "RemoveFromDrafted",
		desc = L["Click per rimuoverlo dai confermati"],
		}})
	ERA.drafted[n].name = n
	ERA.totaldraft = ERA.totaldraft + 1
	ERA:AggiornaMonitor()
end

--aggiunge ai draft o rimuove dal roster a seconda dello stato della checkbox nelle opzioni.
function ERA:ManageMembers(info)
	if self.ar then
		db.raid.roster[info[#info]]=nil
		ERA.roster[info[#info]] = nil
		ERA:SortView(ERA.roster)
	else
		ERA:AddToDrafted(info[#info])	
		ERA:SortView(ERA.drafted)		
	end
end

--aggiunge il nome al roster. non che il roster si usi molto.
function ERA:AddToRoster(info, val)
	if not val then return end	
	val = ERA:Upper1(val)
	db.raid.roster[val] = val
	ERA.roster[val] = setmetatable ({},{__index = {
		order = 10,
		type = "execute",		
		func = "ManageMembers",
		desc = function()
			local d = self.ar and L["rimuoverlo dai membri"] or L["aggiungerlo ai confermati"]
			return (L["Click per "]..d)
		end,
	}})
	ERA.roster[val].name = val,
	ERA:SortView(ERA.roster)
end

--toglie dalla blacklist(per ignorare gli autoinviti di alcuni)
function ERA:RemoveFromBlacklist(info)
	db.whisper.blacklist[info[#info]]=nil
	ERA.blacklist[info[#info]] = nil
	ERA:SortView(ERA.blacklist)
end
--aggiunge dalla blacklist(per ignorare gli autoinviti di alcuni)
function ERA:AddToBlacklist(info, val)
	if not val then return end	
	val = ERA:Upper1(val)
	db.whisper.blacklist[val] = val
	ERA.blacklist[val] = setmetatable({}, {__index = {
		order = 10,
		type = "execute",		
		func = "RemoveFromBlacklist",
		desc = L["Click per rimuoverlo dalla blacklist."],
	}})
	ERA.blacklist[val].name = val
	ERA:SortView(ERA.blacklist)
end
--elimina tutti i confermati in un colpo solo
function ERA:WipeDrafted()
	for name in pairs(db.raid.drafted) do
		ERA.drafted[name]=nil
	end
	db.raid.drafted = {}
	ERA.totaldraft = 0
	ERA:AggiornaMonitor()
end
--evita che i nomi abbiano caratteri non ammessi
function ERA:Validate(info, name)
	if #name < 3 then return L["Nome troppo corto"] end
local forbidden = "([%d:()[%]{}+_=\\|`~,.<>/?!@#$%%^&*])"
	local bad = match(name, forbidden)
	return bad and format(L["Carattere non permesso: %s"], bad) or true
end
--converte la lista manuale nei confermati. Utile per importare la gente dal planner
function ERA:ListToDrafted(info, txt)	
	if not txt then return end
	local wlist = {}
	db.raid.list = txt
	for name in gmatch(txt, "([^%s,]+)") do
		if ERA:Validate(nil,name) == true then 
			name = ERA:Upper1(name)
			wlist[name] = name
		end
	end
	ERA:WipeDrafted()
	for name in pairs(wlist) do	
		ERA:AddToDrafted(name)
	end
	ERA:SortView(ERA.drafted)	
	ERA:AggiornaMonitor()
end
--confermati in formato testuale: per editare la lista nell'editbox del monitor
function ERA:DraftedToList()
	local list = ""
		for name in pairsByKeys(db.raid.drafted) do
			list = format("%s%s, ",list,name)
		end
	return list
end

--esegue una funzione, i vararg sono devono essere già passati come tabella
function ERA:Run(func, args)
	func = type(func) == "function" and func or function()end
	args = args or {}
	args = type(args) ~= "table" and {args} or args
	func(unpack(args))
end
--funzione con un ritardo rispetto all'ultima programmata. per evitare di ammucchiare tanti ordini in pochi millisecondi
function ERA:Timed(func, ...)
	local args = {...}
	self.last = self:ScheduleTimer("Run",self:TimeLeft(self.last)+self.delay,func,args)
			
end
--promuove ad assistente.
function ERA:Promuovi()
	if IsInRaid() and UnitIsGroupLeader("player") and ERA:Getpromozione("assist") then 		
		for name in gmatch(ERA:Getpromozione("assist"), "([^%s,]+)") do			
			if ERA:InRaid(name) and not UnitIsRaidOfficer(name) and not UnitIsUnit(UnitName(name), "player") then 				
			self:Timed(PromoteToAssistant, name)			
				--PromoteToAssistant(name)
			end			
		end
	end
end
--setta il LootMethod e assegna il  Master Looter in base alla lista nelle opzioni. 
function ERA:LootMethod()
	if IsInRaid() and UnitIsGroupLeader("player") then 	
		if not db.promozione.forzaLM then return end
		local method, _, master = GetLootMethod()	
		if method ~= db.promozione.lootMethod then			
				SetLootMethod(db.promozione.lootMethod,UnitName("player"))		
		end
		--regole per impostare il ML secondo la lista 
		if db.promozione.lootMethod =="master" then
			_, _, master = GetLootMethod()
			for name in gmatch(db.promozione.MLooters, "([^%s,]+)") do		
				if not master or UnitIsUnit("raid"..master, ERA:GetName(name)) then return end			
				if ERA:InRaid(name) and (not ERA.EPGP or not ERA.EPGP:RunningRecurringEP()) then		
					SetLootMethod("master",name)				
					return
				end
			end		
			--se il RL da i punti allora deve essere sempre il ML
			if (ERA.EPGP and ERA.EPGP:RunningRecurringEP() and not UnitIsUnit("raid"..master, "player")) then 
				SetLootMethod("master",UnitName("player"))		
			end
		end
	end
end

--tiene aggiornato il raid ed i ruoli
function ERA:GROUP_ROSTER_UPDATE()
	if IsInRaid() then
		self.isInRaid = true
		if UnitIsGroupLeader("player") then									
			self:LootMethod()
			self:Promuovi()
		end
	else
		if not UnitExists("party1") and self.isInRaid then --lascia il raid
			--inserire qui attività da fare quando il raid si disbanda	
			self:RegisterEvent("CHAT_MSG_SYSTEM") 
			ERA:PromozioneCheck()		
			self.isInRaid = nil
			self.startedInviting = nil
			if not db.whisper.alwaysOn and db.whisper.on then
				ERA:SwitchWhisper()
			end
		end
	end
	self:AggiornaMonitor()	
end

--leva/assegna gli assist ai tank che cambiano ruolo
function ERA:ROLE_CHANGED_INFORM(event, cPG, cBy, oldR, newR)
	if not db.promozione.tankAssist then return end
	if IsInRaid() and UnitIsGroupLeader("player") and not(UnitIsUnit(cPG, "player")) and (oldR == "TANK" or newR == "TANK") then
		if newR == "TANK" and not UnitIsRaidOfficer(cPG) then		
			PromoteToAssistant(cPG)				
		elseif oldR == "TANK" and UnitIsRaidOfficer(cPG) then		
			DemoteAssistant(cPG)		
		end	
	end
end

--*************FUNZIONI PER SETTARE I MAIN TANK****************
--le lascio in forma di funzione local per non incasinarmi nelle chiamate
local MTtxt = L["\|cFFFFFF00Assegna i Main Tank\|r"]
local function MTMacro(who, macro)
	if UnitGroupRolesAssigned(who) == "TANK" and not GetPartyAssignment("MAINTANK",who) then
macro = string.format([[%s%s%s
]],macro, "/mt ",who)
	end		
	if UnitGroupRolesAssigned(who) ~= "TANK" and GetPartyAssignment("MAINTANK",who) then
macro = string.format([[%s%s%s
]],macro, "/mtoff ",who)
	end
	return macro
end

--le lascio in forma di funzione local per non incasinarmi nelle chiamate
local function TankAssist(who)
	if UnitGroupRolesAssigned(who) == "TANK" and not UnitIsRaidOfficer(who) and not UnitIsUnit(who, "player") then		
		PromoteToAssistant(who)
	end	
end

function ERA:TankCheck()
	if IsInRaid() and UnitIsGroupLeader("player") then
		local MTMacro, TAss = MTMacro, TankAssist
		--funzione per settare la macro dei MT
		if  not db.opzioni.SetMT then			
			MTMacro = function()end
		end
		--funzione per settare la promozione dei tank
		if not db.promozione.tankAssist then
			TAss = function()end
		end
		--adesso facciamo un ciclo comune
		local macro = ""    
		local who
		for i = 1, GetNumGroupMembers() do
			who = "raid"..i
			macro = MTMacro(who,macro)
			TAss(who)
		end
		if macro ~="" then 
		ERA:AddAlert(MTtxt,"macro",macro)
		--ERA:DialogBox()		
		end
	end
end
--**************FINE MT*************
--setta i main tank
function ERA:READY_CHECK()
	self:TankCheck()
end

function ERA:AddToChatMsgActions(name, pattern)
	ERA.chatMsgActions[name] = gsub(pattern, "%%s", "(%%S+)")
	print(ERA.chatMsgActions[name])
end

function ERA:JOIN()		
	if  self.startedInviting then				
		ConvertToRaid()	
		ERA:AggiornaMonitor()
	end	
end

--l'unica maniera certa per sapere quando qualcuno si unisce al gruppo.
function ERA:CHAT_MSG_SYSTEM(event,txt,...)	 
	if IsInRaid() then 	return end --questo perche' lo usiamo solo per gruppare al momento.		
	local name = match(txt,ERA.JOIN)	
	if name and self.startedInviting then				
		ConvertToRaid()	
		ERA:AggiornaMonitor()
		self:UnregisterEvent("CHAT_MSG_SYSTEM") --da togliere quando lo uso per più di una cosa.
	end
	--se dovessi avere piu' di una ricerca qui uso la funzione seguente
	--[[local found
	for name, pat in pairs(ERA.chatMsgActions) do	
		found = match(txt,pat)		
		if found then 
			assert(ERA[name],format('ERA:CHAT_MSG_SYSTEM "%s" pattern matching, but no function provided', name))
			ERA[name](self) 
		end
	end]]--
end

--indichiamo che siamo durante un incontro, bloccando gli inviti automatici
function ERA:ENCOUNTER_START()
    self.whisperBlock = true	
	ERA:RegisterEvent("PLAYER_REGEN_ENABLED")
end
--riprendiamo gli inviti automtici
function ERA:ENCOUNTER_END()	
	self.whisperBlock = nil
	--ERA:UnregisterEvent("PLAYER_REGEN_ENABLED")	
	self:UpdateGuildRoster()
	--contatta chi voleva essere invitato e digli che può invitarsi, ma solo se i whisper sono attivi
	self:EvadiWhisperInvite()
end

--controllo che l'incontro effettivamente finisca. piano B. ogni tanto encounter_end non viene intercettato.
function ERA:PLAYER_REGEN_ENABLED()	
	local where = ERA:IsGrouped()
	if where then 
		for i = 1, GetNumGroupMembers() do
			if UnitAffectingCombat(where..i) then
				--se ancora qualcuno si mena controlliamo tra un po'
				ERA:ScheduleTimer("PLAYER_REGEN_ENABLED", 3)
				return
			end
		end				
	end
		--se siamo qui nessuno combatte più
	ERA:UnregisterEvent("PLAYER_REGEN_ENABLED")
	ERA:RegisterEvent("PLAYER_REGEN_DISABLED")
	if self.whisperBlock then self.whisperBlock = nil end	
	if not ERA:IsMonitorTest("focus") then ERA:HideAssistMonitor("focus") end
	if not ERA:IsMonitorTest("target") then ERA:HideAssistMonitor("target") end
	self:UpdateGuildRoster()
	--contatta chi voleva essere invitato e digli che può invitarsi, ma solo se i whisper sono attivi
	self:EvadiWhisperInvite()				
end

function ERA:PLAYER_REGEN_DISABLED()
	if ERA:CanMonitorBeShown("target") then ERA:ShowAssistMonitor("target") end
	if ERA:CanMonitorBeShown("focus") then ERA:ShowAssistMonitor("focus") end
	ERA:UnregisterEvent("PLAYER_REGEN_DISABLED")
	ERA:RegisterEvent("PLAYER_REGEN_ENABLED")   
end

function ERA:Invita(name,bnet,TID)
	if not UnitIsUnit(ERA:GetName(name), "player") then 						
		--se non sono gia' nel party
		if not UnitPlayerOrPetInRaid(name) and not UnitPlayerOrPetInParty(name) and not UnitPlayerOrPetInRaid(ERA:GetName(name)) and not UnitPlayerOrPetInParty(ERA:GetName(name))then		
			self.startedInviting = true
			if not (bnet and TID) then
				InviteUnit(name)			
			else
				BNInviteFriend(TID)
			end
		end
	end
end

--una coda di inviti. attualmente usata solo se qualcuno cerca di autoinvitarsi durante un incontro.
function ERA:EvadiWhisperInvite()
	if ERA.evadingWhisper then return end
	ERA.evadingWhisper = true
	local who,i
	while #self.invitiRichiesti > 0 do 
		who = self.invitiRichiesti[#self.invitiRichiesti]
		if not ERA:InRaid(who) then
			self:WhisperInvita(who)
		end			
		table.remove(self.invitiRichiesti)		
	end
	ERA.evadingWhisper = nil
end

function ERA:ScheduleEvadiWhisper()
	if not self.scheduled then
		self.scheduled = self:ScheduleTimer("EvadiWhisperInvite",10)
	end
end

function ERA:Whisper(msg, to, bnet)
	if not bnet then
		SendChatMessage(msg,"WHISPER", nil, to)
	else
		BNSendWhisper(bnet, msg)
	end
end

--gestisce l'autoinvito con le sua varie varianti
function ERA:WhisperInvita(name,bnet,TID)--name deve essere nella forma nome-server,bnet per i whisper da bnet,TID = toonID per BNInvite

	if ERA:InRaid(name) then return end
	-- persone non nella blacklist
	if next(db.whisper.blacklist) and (db.whisper.blacklist[name] or db.whisper.blacklist[ERA:GetName(name)]) then
	   ERA:Whisper(L["TU.. NON PUOI.. RAIDARE!"], name, bnet)
	   return
	end
	
	--se è sicuro e siamo nel self:whisperBlock non invitiamo
	if db.whisper.safe and self.whisperBlock then
		ERA:Whisper(L["Incontro in corso, riprova più tardi."], name, bnet)
		tinsert(self.invitiRichiesti,name)
		return
	end       
	
	--solo gildani
	if db.whisper.guildOnly and IsInGuild() then 	
		local sName = ERA:GetName(name,true)
		local rank, rankIndex, lvl = self:IsInMyGuild(sName)
		if not rank then 
			ERA:Whisper(L["Solo per gildani"], name,bnet) 			
			return 
		end --è non è gildano non invitiamo
		if db.whisper.maxLvlOnly and lvl < ERA.maxLvl then return end
		if db.whisper.minRank and db.whisper.minRankLvl and rankIndex > db.whisper.minRankLvl then return end							
	end
	
	self:Invita(name,bnet,TID)
end

--cosi' per evitare duplicazioni. la lista e' creata in fase di login o quando si modificano le opzioni
function ERA:WhisperKWordIsRight(kword)
		if not kword or kword =="" then return end		
		if ERA._kWords[kword] then return true end
end
--la lista e' creata in fase di login o quando si modificano le opzioni
function ERA:KwordListToTable()
	local kWords = {}
	local list = ERA:Getwhisper("kwordList")
	if list and list ~= "" then 
		if not ERA:Getwhisper("casesensitive") then
			list = lower(list)
		end	
		for k in gmatch(list, "([^%s,]+)") do
			kWords[k] = k			
		end
	end
	ERA._kWords = kWords
end

--intercetta gli inviti con i whisper
function ERA:CHAT_MSG_WHISPER(event, txt, sender)--sender e' nella forma nome-server
	if ERA:WhisperKWordIsRight(txt) then
		self:WhisperInvita(sender)
	end
end

function ERA:CHAT_MSG_BN_WHISPER(_,txt,_,_,_,_,_,_,_,_,_,_,_,PID)
   if not ERA:WhisperKWordIsRight(txt) then return end
   local _,numFriends = BNGetNumFriends() 
   for i=1,numFriends do 
      local ctrPID,_,_,_,toon,toonID = BNGetFriendInfo(i)
      if PID == ctrPID and toonID then
         local _,_,_,realm = BNGetToonInfo(toonID)
         if realm and realm ~="" then
            toon = format("%s-%s",toon, gsub(realm, "%s",""))               
         end         
         self:WhisperInvita(toon, PID, toonID)
         return                
      end
   end 
end

--WHISPER
--attiva o disattiva l'autoinvito. ignorato se si e' messo che deve essere sempre ON nelle opzioni
function ERA:SwitchWhisper(silent)	
	db.whisper.on = not db.whisper.on	
	if db.whisper.alwaysOn then		
		db.whisper.on = true
	end
	
	if not db.whisper.on then	
		self:UnregisterEvent("CHAT_MSG_WHISPER")	
		ERA:UnregisterEvent("CHAT_MSG_BN_WHISPER")
		print(off)
	else
		self:RegisterEvent("CHAT_MSG_WHISPER")
		ERA:RegisterEvent("CHAT_MSG_BN_WHISPER")
		if db.whisper.annuncia and not silent then
			SendChatMessage(db.whisper.startMsg,"GUILD")
		end
		if db.opzioni.monitor and not silent then
			self:ShowMonitor()
		end		
		if not next(ERA.cachedRoster) then
			self:UpdateGuildRoster()	 
		end
		print(format("%s%s",on, db.whisper.alwaysOn and L[" SEMPRE!"] or ""))
	end
	self:AggiornaMonitor()
end

--name deve essere nella forma nome-server, lavora con la funzione cachingRoster
function ERA:IsInMyGuild(name) 
	if name and self.cachedRoster[name] then 
	local i = self.cachedRoster[name]
		return i.rank, i.rankIndex, i.lvl
	end
end

--return status red green o nil se non in gilda; cicla la lista di gilda, più lento (millisecondi) ma più affidabile 
--comunque non affidabile al 100% maledetta blizzard
function ERA:IsOnline(name)	
	local sName = ERA:GetName(name, true)	
	if not self:IsInMyGuild(sName) then return end --non ci mettiamo a cercare troppo se non e' in gilda, nessuna query al server	
	local fullName,online
	for i = 1, GetNumGuildMembers() do
	fullName,_,_,_ ,_,_,_,_, online = ERA:GetGuildRosterInfo(i) 
		if fullName == sName then 
			if online then 
				return L["Online"], 0, 1
			else
				return L["Offline"], 1, 0
			end
		end
	end	
	ERA:UpdateGuildRoster(true)--vediamo se fixa la rilevazione.
end
--copia il roster di gilda in una cache locale, per sapere in fretta se un'unità è un gildano. Memoria occupata risibile.
function ERA:CachingRoster()		
	self.cachedRoster = {}
	local fullName, rank, rankIndex, lvl -- per ERA:GetGuildRosterInfo
	for i = 1, GetNumGuildMembers() do
		fullName, rank, rankIndex,lvl,_,_,_,_, online = ERA:GetGuildRosterInfo(i) 
		self.cachedRoster[fullName] = {			
			["rank"] = rank, 
			["rankIndex"] = rankIndex, 			
			["lvl"] = lvl,
			["online"] = online
		}		
	end	
	self.fullRosterCaching = not next(self.cachedRoster)
	return not self.fullRosterCaching
end

--richiede l'update del guildroster ed eventualmente setta di copiarlo nella cache
--la copia la chiediamo al login/ricarica per controllare rapidamente chi è in gilda e chi no
--effettua 2 chiamate, una subito e una dopo 10 secondi, perchè a volte la chiamata viene ignorata. il server risponde infatti approssimativamente ogni 10 secondi (in realtà risponde prima, dato che ogni volta che qualcuno logga la finestra di gilda si aggiorna).
--la seconda chiamata viene cancellata se i dati di gilda sono disponibili prima.
function ERA:UpdateGuildRoster(notCaching)
	local timing = 10
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	GuildRoster()	
	if not self.updatingGuildRoster then 
		self.updatingGuildRoster = ERA:ScheduleTimer("UpdateGuildRoster", timing)
	end
	self.fullRosterCaching = not notCaching
end

--controlla quando si aggiorna il roster di gilda
function ERA:GUILD_ROSTER_UPDATE()
	--la seconda chiamata viene cancellata se i dati di gilda sono disponibili prima.
	if self.updatingGuildRoster then ERA:CancelTimer(self.updatingGuildRoster) end
	if self.fullRosterCaching then
		local guildDataAvailables = self:CachingRoster()	
		ERA:CoerenzaRanghiCheck()
		if guildDataAvailables then 
			if ERA.ExtremaIni then
				ERA:Extrema()
				--ERA:DialogBox()
			end
			if self.checkPromozioni then
				if not IsInRaid() then
					self:PromozioneCheck()
				end
				self.checkPromozioni = nil
			end
		end
	end		
end

--serve per vedere se il rank progress è attivo nonostante tutto
function ERA:PromozioneCheck()
	self.checkPromozioni = nil
	local rankIndex
	if db.promozione.up then 		
		local f
		for i = 1, GetNumGuildMembers() do
			_,_, rankIndex = ERA:GetGuildRosterInfo(i) 
			if db.promozione.up == rankIndex then 
				f = true 				
				break
			end		
		end		
		if f then			
			local act = CanGuildDemote() and L["Premi OK per sistemarlo ora"] or ""
			local msg = format(L["Persone al grado \|cFFFFFF00%s\|r.\n%s."], self.ranks[db.promozione.up], act)		
			ERA:AddAlert(msg, CanGuildDemote() and ERA.DialogBoxOpenToTab or function()end,this,"promozione")
			--ERA:DialogBox()
		else
			db.promozione.ultraPromossi = {}			
		end	
	end		
end

function ERA:CoerenzaRanghiCheck()
	if not IsInGuild() then return end
--controlli sui ranghi di gilda salvati e attuali
	if db.whisper.minRank and db.whisper.minRankLvl and self.ranks[db.whisper.minRankLvl] ~= db.whisper.minRankName then
		local msg = L["Incongruenza tra i ranghi attuali di gilda e quelli salvati. Premi \|cFFFF0000OK\|r per controllare."]
		ERA:AddAlert(msg, ERA.DialogBoxOpenToTab,this,"whisper")
	end

	if (db.promozione.up and self.ranks[db.promozione.up] ~= db.promozione.upName) or (db.promozione.down and self.ranks[db.promozione.down] ~= db.promozione.downName) then
		local msg = L["Incongruenza tra i ranghi attuali di gilda e quelli salvati. Premi \|cFFFF0000OK\|r per controllare."]
		ERA:AddAlert(msg, ERA.DialogBoxOpenToTab,this,"promozione")
	end	
end

function ERA:CanPromote()
	local name = ERA:GetName(GetUnitName("player"),true)
	local _, rankIndex = ERA:IsInMyGuild(name)
	return ((IsInRaid() or IsInGroup()) and CanGuildPromote() and db.promozione.up and db.promozione.up > rankIndex and not self.fullRosterCaching)	
end
--promozione ai rank scelti
function ERA:PromuoviGilda()
	if not ERA:CanPromote() then return end --se non puoi promuovere non ci scomodiamo		
	local membri = GetNumGroupMembers()
	if membri <1 then return end --sarebbe un controllo già fatto a dire il vero.
	self:UnregisterEvent("GUILD_ROSTER_UPDATE")	
	self.fullRosterCaching = true --anticipiamo il valore per evitare doppi click
	local name, rankIndex
	local where = ERA:IsGrouped()
	local wt = {} --la lista di tutti quelli che potenzialmente dovremmo promuovere
	for i = 1, membri do 
		name = ERA:GetName(GetUnitName(where..i,true),true)--serve forma nome-server quindi lo forzo		
		_,rankIndex = ERA:IsInMyGuild(name)
		if  rankIndex then --se e' di gilda lo inseriamo nella lista 			
			wt[name] = rankIndex
		end
	end
	--creata la lista facciamo le effettive promozioni	
	membri = GetNumGuildMembers()
	for i = 1, membri do	
		if not next(wt) then break end
		name, _, rankIndex = ERA:GetGuildRosterInfo(i)
		if wt[name] and rankIndex and rankIndex > db.promozione.up then			
			if db.promozione.down and rankIndex > db.promozione.down then
				db.promozione.ultraPromossi[name] = rankIndex	 --salviamo una lista con il rank di chi e' stato promosso da gradi bassi
			end
			SetGuildMemberRank(i, db.promozione.up)			
			wt[name] = nil	
		end		
	end	
	self:UpdateGuildRoster()
	--qui invia il messaggio che ho promosso agli altri addon e manda la lista
end

function ERA:CanDemote()	
	local name = ERA:GetName(GetUnitName("player"),true)
	local _, rankIndex = ERA:IsInMyGuild(name)
	return (CanGuildDemote() and db.promozione.up and db.promozione.up > rankIndex and db.promozione.down and db.promozione.down > rankIndex and db.promozione.down > db.promozione.up and not self.fullRosterCaching)
end
--degrada l rank scelto (o sotto se partivi da più basso)
function ERA:DegradaGilda()
	if not ERA:CanDemote() then return end --se non puoi degradare non ci scomodiamo			
	self:UnregisterEvent("GUILD_ROSTER_UPDATE")	
	self.fullRosterCaching = true --anticipiamo il valore per evitare doppi click
	local name, rankIndex, newRank
	--scorriamo tutta la gilda, troviamo chi e' al livello incriminato e lo potiamo in basso. riportiamo chi era ancora più in basso al livello originale
	for i = 1, GetNumGuildMembers() do	
		name, _, rankIndex = ERA:GetGuildRosterInfo(i)		
		if rankIndex and rankIndex == db.promozione.up then --se e' stato promosso
			if db.promozione.ultraPromossi[name] then 
				newRank = db.promozione.ultraPromossi[name]
				db.promozione.ultraPromossi[name] = nil
			else
				newRank = db.promozione.down
			end
			SetGuildMemberRank(i, newRank)				
		end
	end
	self:UpdateGuildRoster()
	--qui volendo invia il messaggio che ho promosso agli altri addon e manda la lista
end

function ERA:CheckWspMsg(msg)

end



--era i o i pulsanti di invito
--effettua 2 tentativi di invito dei confermati a distanza di qualche secondo
function ERA:MassInvite()
	ERA:StartInvite()
	ERA:ScheduleTimer("StartInvite", ERA.totaldraft *0.5+20)
end
--invita tutti i confermati
function ERA:StartInvite()
	if not next(db.raid.drafted) then return end	
	--scorre la lista dei confermati e li invita
	if db.opzioni.monitor then
		self:ShowMonitor()
	end	
	for name in pairs(db.raid.drafted) do	
		self:Invita(name)
	end	
end



--****EPGP
--funzioni e controlli per i pulsanti di EPGP, per compattare le azioni in pochi tasti
--usa bottoni dinamici
function ERA:CanClickEPGPBtn(btn)
	local b = db.opzioni.EPGPUICfg[btn]
	return (ERA.EPGP and db.opzioni.EPGP and IsInRaid() and UnitIsGroupLeader("player") 
				and (not b.decay or ERA.EPGP:CanDecayEPGP())
				and (not b.award or ERA.EPGP:CanIncEPBy(b.reason, b.awardAmount))
				and (b.recurring == "start" and not ERA.EPGP:RunningRecurringEP() and ERA.EPGP:CanIncEPBy(b.reason, b.recurringAmount)
					or (b.recurring == "stop" and ERA.EPGP:RunningRecurringEP())
					or (b.recurring ~= "stop" and b.recurring ~= "start")
				)
			)
end
--usata nei bottoni dinamici
function ERA:ClickEPGPBtn(btn)
	local t = db.opzioni.EPGPTimer or 1 --il tempo di sicurezza, per evitare che EPGP si incasini con la scrittura nelle note di gilda.
	local b = db.opzioni.EPGPUICfg[btn]
	for k in pairs(db.opzioni.EPGPUICfg) do --disabilitiamo tutti i pulsanti per evitare doppi click, ed altri errori
		ERA.Monitor.Frame[k]:SetDisabled(true)
	end
	if b.recurring == "stop" then  
		EPGP:StopRecurringEP() 
	end
	if b.decay then 
		ERA:ScheduleTimer(function()ERA.EPGP:DecayEPGP() end, t) 
		t = t+3
	end
	if b.award then 
		ERA:ScheduleTimer(function()ERA.EPGP:IncMassEPBy(b.reason, b.awardAmount) end, t) 
		t = t+3
	end
	if b.recurring == "start" then 
		ERA.EPGP:RecurringEPPeriodMinutes(b.recurringTime)
		ERA:ScheduleTimer(function()ERA.EPGP:StartRecurringEP(b.reason, b.recurringAmount)end, t)
		t = t+1
	end
	ERA:ScheduleTimer(function()ERA:AggiornaMonitor()end, t)--riabilitiamo i giusti pulsanti
end

function ERA:EPGPBtnOptions()
	local btn = {
		type = "group",
		order = 10,
		inline = true,
		name = L["Pulsante"],
		desc =L["Seleziona le azioni che il pulsante deve automatizzare."],
		set = function(info, val)
			ERA:DBSet(info, val)
			ERA:AggiornaMonitor()
			--ERA:HelpOptions()
		end,
		args = {
			txt = {
				type = "input",
				order = 10,
				name = L["Nome"],
				desc = L["Il testo scritto nel pulsante. La prima parola costituisce anche un comando usabile in chat (cfr lista comandi)."],
				set = function(info,val) 
					ERA:DBSet(info, val)
					if ERA.Monitor and ERA.Monitor.Frame[info[#info-1]] then
						ERA.Monitor.Frame[info[#info-1]]:SetText(val)
					end
					ERA:DelEPGPBtnFromSlashCmd(info[#info-1])
					ERA:AddEPGPBtnToSlashCmd(info[#info-1])
				end,
			},
			decay = {
				type = "toggle",
				order = 20,
				name = L["Decay"],
				desc = L["Il pulsante effettua il decay."],
			},
			space = {
				type = "description",
				order = 30,
				width = "full",
				name = "",
			},
			award = {
				type = "toggle",
				order = 40,
				name = L["Mass EP Award"],
				desc = L["Il pulsante  assegna punti EP al raid."],
			},
			awardAmount = {
				type = "range",
				order = 50,
				min = 0,
				softMin = 50,
				softMax = 150,
				step = 1,
				name = L["EP"],
				desc = L["EP da assegnare."],			
				hidden = function(info)
					return not db.opzioni.EPGPUICfg[info[#info-1]].award
				end,
			},
			reason = {
				type = "input",
				order = 60,
				name = L["Motivo"],
				desc = L["Il motivo per il quale si danno i punti."],
				hidden = function(info) return not (db.opzioni.EPGPUICfg[info[#info-1]].award or db.opzioni.EPGPUICfg[info[#info-1]].recurring == "start") end,
			},
			space2 = {
				type = "description",
				order = 70,
				width = "full",
				name = "",
			},
			recurring = {
				type = "select",
				order = 80,
				values = {["start"]="Start",["stop"]="Stop",["no"]="No",},
				name = L["Recurring EP"],
				desc = L["Il pulsante assegna punti EP ricorrenti al raid o li ferma, o non influenza i punti ricorrenti (default)."],			
			},
			recurringAmount = {
				type = "range",
				order = 90,
				min = 0,
				softMin = 50,
				softMax = 150,
				step = 1,
				name = L["EP"],
				desc = L["EP da assegnare."],			
				hidden = function(info)
					return db.opzioni.EPGPUICfg[info[#info-1]].recurring ~= "start"
				end,
			},
			recurringTime = {
				type = "range",
				order = 100,
				min = 1,
				softMin = 5,
				softMax = 60,
				step = 1,
				name = L["Tempo (in minuti)"],
				desc = L["Frequenza di assegnazione dei punti ricorrenti."],			
				hidden = function(info)
					return db.opzioni.EPGPUICfg[info[#info-1]].recurring ~= "start"
				end,
			},
		},
	}
	ERA.EPGPBtnOptionsDef = btn
end

function ERA:NewEPGPBtnOpt(b)
	local n = type(b) =="string" and match(b,"(%d+)") or b
	local btn = setmetatable({}, {__index = ERA.EPGPBtnOptionsDef,})
	btn.order = n*10
	btn.name = btn.name..n	
	self.EPGPBtns["btn"..n] = btn
end

function ERA:AddNewEPGPBtn()		
	local n = 1
	for k in pairs(db.opzioni.EPGPUICfg) do
		n = n+1
	end
	local btn = "btn"..n
	db.opzioni.EPGPUICfg[btn] = {}
	db.opzioni.EPGPUICfg[btn].txt = format("%s %s", L["Pulsante"],n)
	ERA:NewEPGPBtnOpt(n)
	ERA:AddEPGPBtnToSlashCmd(btn)
	return n
end

--***********MONITOR***************

function ERA:CanInvite()
	return (not IsInGroup() and not IsInRaid()) or UnitIsGroupLeader("player") or UnitIsRaidOfficer("player")	
end

function ERA:MonitorLabelClick(w)

	if not ERA:CanInvite() then return end
	local stato = w:GetUserData("stato")
	local nome = w:GetUserData("nome")	
	local act = w:GetUserData("azione")	
	if act then
		if stato == status.potenziale then
			self:RegisterEvent("GROUP_ROSTER_UPDATE")
			self:Invita(nome)		
		end
		if stato == status.imbucato then
			UninviteUnit(nome)		
		end
	end
end

function ERA:InviteTooltipShow(w)
	local stato = w:GetUserData("stato")	
	local nome = w:GetUserData("nome")
	local act = stato ~= status.accettato and ERA:CanInvite() or nil
	w:SetUserData("azione", act)	
	local statoDes = format(aspetto[stato].txt,aspetto[stato].tooltip)		
	local action = format(aspetto[stato].txt,aspetto[stato].action)
	local cnctd, r, g = self:IsOnline(nome)		
	GameTooltip:SetOwner(w.frame,"ANCHOR_TOPLEFT")
	GameTooltip:SetText(statoDes)	
	if cnctd then
		GameTooltip:AddLine(cnctd,r,g,0) 						
	end
	if act and cnctd ~= L["Offline"] then
		GameTooltip:AddLine(action) 
	end
	GameTooltip:Show()
end

function ERA:EPGPBtnDesc(b)
	local txt = ""
	local btn = db.opzioni.EPGPUICfg[b]
	txt = format("%s%s", txt, btn.decay and L["effettua il decay, "] or "")
	txt = format("%s%s", txt, btn.award and format(L["da %s punti, "], btn.awardAmount or 0 ) or "")
	txt = format("%s%s", txt, btn.recurring == "start" and format(L["fa partire i punti dando %s EP ogni %s minuti."],btn.recurringAmount or 0,btn.recurringTime or 5) or "")		
	txt = format("%s%s", txt, btn.recurring == "stop" and L["ferma i punti EP ricorrenti."] or "")		
	txt = ERA:Upper1(txt)
	txt = gsub(txt,",%s$",".")
	return txt
end

function ERA:BtnTooltipShow(w)	
	GameTooltip:SetOwner(w.frame,"ANCHOR_TOPLEFT")
	local txt = ""
	if w:GetUserData("tipo")== "EPGPBtn" then
		txt = ERA:EPGPBtnDesc(w:GetUserData("btn"))
	else
		txt = w:GetUserData("tltp")
	end
	GameTooltip:SetText(txt)
	GameTooltip:Show()
end

function ERA:TooltipHide()
	GameTooltip:Hide()
end

function ERA:MonitorUpdteList()
	if ERA.Monitor and ERA.Monitor:IsVisible() then
		ERA.Monitor.Drafted:SetText(ERA:DraftedToList())
	end	
end

function ERA:CreaLabel(name, i,stato)
	local label = "invito"..i
	local m = ERA.Monitor.Inviti	
--[[	ICONA	]]--
	m[label] = ACEGUI:Create("Icon")	
	m[label]:SetImage(aspetto[stato].icona)	
	m[label]:SetLabel(format(aspetto[stato].txt,name))	
	m[label]:SetImageSize(12,12)	
	m[label]:SetUserData("nome",name)
	m[label]:SetUserData("stato",stato)
	m[label]:SetCallback("OnEnter",function()ERA:InviteTooltipShow(m[label])end)
	m[label]:SetCallback("OnLeave",function()ERA:TooltipHide()end)
	m[label]:SetCallback("OnClick", function() ERA:MonitorLabelClick(m[label]) end)
	m:AddChild(m[label])
	
	return m[label]
end

--crea i nomi colorati per sapere chi abbiamo invitato o dobbiamo invitatare
function ERA:AggiornaVistaInviti()
	if not ERA.Monitor then return end	
	
	if ERA.UNKNOWN then --un aggiornamento per i fatti suoi è arrivato prima di quello fatto per fixare i nomi.
		ERA:CancelTimer(ERA.UNKNOWN)
	end
	
	ERA.Monitor.Inviti:ReleaseChildren()
	local r = 0
	local s = status.potenziale
	--intanto segnala tutti i confermati e il loro status.
	for nome in pairsByKeys(db.raid.drafted) do
		if not UnitIsUnit(ERA:GetName(nome), "player") then			
			if not ERA:InRaid(nome) and not ERA:InRaid(ERA:GetName(nome)) and not ERA:InRaid(ERA:GetName(nome,true)) then
				s = status.potenziale --(rosso)
			else
				s = status.accettato				
			end
			r = r+1
			self:CreaLabel (nome, r, s)
		end
	end
	--poi scorre la lista del gruppo e guarda se ci sono persone fuori dai confermati
	self.imbucati = 0
	if IsInRaid() then 
		for i = 1, GetNumGroupMembers() do
			if not UnitIsUnit("raid"..i,"player") then
				nome = GetUnitName("raid"..i, true)	
				if find(nome, UNKNOWNOBJECT) or find(nome, UNKNOWN) then
					ERA.UNKNOWN = ERA:ScheduleTimer("AggiornaVistaInviti",2)
				end
				snome = ERA:GetName(nome,true)
				dnome = ERA:GetName(nome)
				if not db.raid.drafted[nome] and not db.raid.drafted[snome] and not db.raid.drafted[dnome] then --BUG una persona con lo stesso nome ma di server differenti non risulta correttamente. Troppa fatica risolverlo
					r = r+1
					self.imbucati = self.imbucati + 1
					s = status.imbucato
					self:CreaLabel (nome,r,s) 
				end
			end
		end	
	end
end

function ERA:CreateMonitorUI()
	if not ERA.Monitor then return end
	ACEGUI = LibStub("AceGUI-3.0")
	local m = ERA.Monitor.Frame
	local m1 = ERA.Monitor
	--pulisce il vecchio
	m:ReleaseChildren()
	--Pulsanti per il controllo degli epgp
	--costruisce i nuovi (se c'e' EPGP e db.opzioni.EPGP)
	if ERA.EPGP and db.opzioni.EPGP then
		for k,v in pairsByKeys(db.opzioni.EPGPUICfg) do
			m[k] = ACEGUI:Create("Button")
			m[k]:SetText(v.txt)
			m[k]:SetRelativeWidth(0.5)
			m[k]:SetCallback("OnClick", function() ERA:ClickEPGPBtn(k) end)	
			m[k]:SetCallback("OnLeave", function() ERA:TooltipHide() end)	
			m[k]:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m[k]) end)	
			m[k]:SetUserData("btn", k)--stesso comando di /era		
			m[k]:SetUserData("tipo", "EPGPBtn")
			m:AddChild(m[k])
		end
	end
	--editbox per la lista dei confermati
	m.Drafted = ACEGUI:Create("MultiLineEditBox")
	m1.Drafted = m.Drafted
	m.Drafted:SetNumLines(3)
	m.Drafted:SetRelativeWidth(1)
	m.Drafted:SetLabel(L["Lista confermati/Da Invitare"])
	m.Drafted:SetCallback("OnEnterPressed", function(widget, event, txt) widget:SetText(txt) 
			db.raid.list = txt
			ERA:ListToDrafted(_, txt) 
		end)
	m.Drafted:SetText(ERA:DraftedToList())
	m:AddChild(m.Drafted)	

	--pulsante invita
	m.Invita = ACEGUI:Create("Button")
	m.Invita:SetText(L["Invita confermati"])
	m.Invita:SetRelativeWidth(0.5)
	m.Invita:SetCallback("OnClick", function(...) ERA:MassInvite()	end)
	m.Invita:SetCallback("OnLeave", function() ERA:TooltipHide()	end)	
	m.Invita:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m.Invita) end)	
	m.Invita:SetUserData("tltp", ERA.Com["i"].desc)--stesso comando di /era		
	m:AddChild(m.Invita)
	
	--whisper
	m.Whisp = ACEGUI:Create("Button")
	m.Whisp:SetText(L["Inviti da Whisper"]) 
	m.Whisp:SetRelativeWidth(0.5)
	m.Whisp:SetCallback("OnClick", function(...) ERA:SwitchWhisper() end)
	m.Whisp:SetCallback("OnLeave", function() ERA:TooltipHide()	end)	
	m.Whisp:SetCallback("OnEnter", function() ERA:BtnTooltipShow(m.Whisp) end)	
	m.Whisp:SetUserData("tltp", ERA.Com["w"].desc)--stesso comando di /era		
	m:AddChild(m.Whisp)
	
	--contenitore per invitati/confermati
	m.Inviti = ACEGUI:Create("InlineGroup")
	m1.Inviti = m.Inviti
	m.Inviti:SetTitle(L["Invitati/confermati"])
	m.Inviti:SetRelativeWidth(1)
	m.Inviti:SetLayout("Flow")
	m:AddChild(m.Inviti)
end

function ERA:IniMonitor()
	ACEGUI = LibStub("AceGUI-3.0")
	local m1 = ACEGUI:Create("Frame")
	ERA.Monitor = m1	
	m1:SetTitle("Monitor Inviti")
	self:UpdateStatus()	
	m1:SetLayout("fill")
	m1:SetWidth(500)	
	local m = ACEGUI:Create("ScrollFrame")
	m:SetLayout("flow")
	m1:AddChild(m)
	ERA.Monitor.Frame = m
	ERA:CreateMonitorUI()
	m1:Hide()
end

function ERA:UpdateStatus()
	if not ERA.Monitor then return end
	local txt = ""
	txt = format("%s%s%s%s%s", ERA.totaldraft > 0 and ERA.totaldraft or "", ERA.totaldraft > 0 and L[" confermati, "] or "", 
	self.imbucati > 0 and self.imbucati or "", self.imbucati > 0 and L[" \|cFF69CCF0imbucati\|r, "] or "", 
	db.whisper.on and on or off)
	ERA.Monitor:SetStatusText(txt)
end

function ERA:AggiornaMonitor()
	if ERA.Monitor and ERA.Monitor:IsVisible() then
		ERA:MonitorUpdteList()
		self:AggiornaVistaInviti()
		self:UpdateStatus()
		--setta la cliccabilità dei pulsanti EPGP
		for k in pairs(db.opzioni.EPGPUICfg) do
			if ERA.Monitor.Frame[k] then
				ERA.Monitor.Frame[k]:SetDisabled(not ERA:CanClickEPGPBtn(k))
			end
		end
	end
end

function ERA:ShowMonitor()
	if not ERA.Monitor then
		self:IniMonitor()
	end
	self.Monitor:Show()	
	self:AggiornaMonitor()		
end
--**************BOX**********************
--***************************************
function ERA:DialogBoxOpenToTab(tab)
	LibStub("AceConfigDialog-3.0"):Open(addonName)	
	LibStub("AceConfigDialog-3.0"):SelectGroup(addonName, tab)
end

--crea e visualizza la coda di stampa
function ERA:AddAlert(msg, action, ...)
	local args = {...}
	local vars = { msg = msg, action = action, args = args,}
	tinsert(self.msgBuffer, vars)	
	ERA:DialogBox()
end

--mostra il primo messaggio in coda. alla chiusura richiama se stessa per mostrare eventuali altri o esce
function ERA:DialogBox()
	if ERA.Box and ERA.Box:IsShown() then return end
	local msg, action, args 
	if self.msgBuffer[1] then 
		msg = self.msgBuffer[1].msg		
		action = self.msgBuffer[1].action
		args = self.msgBuffer[1].args
		tremove(self.msgBuffer, 1)
	else
		return
	end	
	if not ERA.Box then
		local b = CreateFrame("Frame", nil, UIParent)
		b:SetWidth(250)
		b:SetHeight(150)
		b:SetPoint("CENTER", UIParent,"TOP",0,-150)

		b:SetBackdrop({
		  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		  tile = true,
		  tileSize = 32,
		  edgeSize = 32,
		  insets = { left=11, right=12, top=12, bottom=11 }
		}) 
		ERA.Box = b
		
		txt = b:CreateFontString()
		txt:SetFontObject(GameFontNormal)
		txt:SetTextColor(1, 1, 1)
		txt:SetPoint("TOP",b,"TOP",0,-25)
		txt:SetWidth(b:GetWidth()*0.75)
		txt:SetWordWrap(true)		
		ERA.Box.txt = txt
		
		local btnC = CreateFrame("Button",nil, b, "UIPanelButtonTemplate")
		btnC:SetWidth(75)
		btnC:SetHeight(30)
		btnC:SetPoint("BOTTOMLEFT", b, "BOTTOM", 5, 15)
		btnC:SetText(L["CANCEL"])
		btnC:SetScript("OnClick", function() b:Hide() end)	
		btnC:SetScript("PostClick", function() ERA:DialogBox() end)
		
		local btnK = CreateFrame("Button",nil, b, "SecureActionButtonTemplate,UIPanelButtonTemplate")
		btnK:SetWidth(75)
		btnK:SetHeight(30)
		btnK:SetPoint("BOTTOMRIGHT", b, "BOTTOM", -5, 15)
		btnK:SetAttribute("type", "macro")
		btnK:SetText(L["OK"])		
		ERA.Box.btnK = btnK
		b:Hide()
	end
	if action and action =="macro" and args and type(args[1]) == "string" then
		ERA.Box.btnK:SetAttribute("macrotext", args[1])		
	end
	ERA.Box.btnK:SetScript("PostClick", function() 
			ERA:Run(action,args)
			ERA.Box.btnK:SetAttribute("macrotext", "")
			ERA.Box:Hide()		
			ERA:DialogBox() 		
		end)		
	ERA.Box.txt:SetText(msg or "")		
	ERA.Box:Show()
end

function ERA:IniExtremaDB()
	if db.ExtremaIni then ERA.ExtremaIni = nil return end
	local i,btn,b
	local EPGPBtns = {
		{
			["txt"] = "Start EPGP",
			["recurring"] = "start",
			["decay"] = true,
			["award"] = true,
			["recurringTime"] = 30,
			["awardAmount"] = 100,
			["recurringAmount"] = 70,
			["reason"] = "Inizio Raid",
		},	
		{
			["txt"] = "Stop EPGP",
			["recurring"] = "stop",
			["awardAmount"] = 100,
			["award"] = true,
			["reason"] = "Fine Raid",	
		},
	}
	
	for _, t in ipairs(EPGPBtns) do
		i = ERA:AddNewEPGPBtn()
		btn = "btn"..i
		b = db.opzioni.EPGPUICfg[btn]
		for k, v in pairs(t) do
			b[k]=v
		end
		ERA:NewEPGPBtnOpt(btn)
		ERA:DelEPGPBtnFromSlashCmd(btn)
		ERA:AddEPGPBtnToSlashCmd(btn)
	end
	--
	db.roster = nil
	db.raid.roster = db.raid.roster or {
				["Galahtea"] = "Galahtea",["Séntenza"] = "Séntenza",["Petàrdo"] = "Petàrdo",["Sünny"] = "Sünny",["Reeve"] = "Reeve",["Clodefox"] = "Clodefox",	["Virust"] = "Virust",
				["Stormbeard"] = "Stormbeard",["Oxs"] = "Oxs",["Herdek"] = "Herdek",["Petardo"] = "Petardo",["Lunchi"] = "Lunchi",["Wuaca"] = "Wuaca",["Kichiga"] = "Kichiga",
				["Niikko"] = "Niikko",["Elowolf"] = "Elowolf",["Figolas"] = "Figolas",["Paryde"] = "Paryde",["Driedin"] = "Driedin",["Ossimoro"] = "Ossimoro",["Artémisìa"] = "Artémisìa",["Zandal"] = "Zandal",["Monnez"] = "Monnez",["Molokk"] = "Molokk",["Davided"] = "Davided",["Rèalangel"] = "Rèalangel",["Itzigo"] = "Itzigo",["Lygeìa"] = "Lygeìa",["Teobarbo"] = "Teobarbo",["Koccolina"] = "Koccolina",["Jeyla"] = "Jeyla",
			}

	db.promozione["up"] = 5--grado per la promozione		
	db.promozione["upName"] = "Progress" --nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
	db.promozione["downName"] = "Legionario"--nome del grado. usato per controllare che non ci siano stati cambiamenti nei gradi di gilda
	db.promozione["down"] = 6--grado per la retrocessione
	db.promozione["MLooters"] = ""--list ML			
	db.promozione.assist="Stormbeard, Niikko" --lista assist

	db.ExtremaIni = true
	ERA.ExtremaIni = nil
end

function ERA:Extrema()	
	if db.ExtremaIni then ERA.ExtremaIni = nil return end	
	db.timesAskedExtremaIni =  db.timesAskedExtremaIni and db.timesAskedExtremaIni + 1 or 1
	if db.timesAskedExtremaIni > 3 then db.ExtremaIni = true; ERA.ExtremaIni = nil; return end	
	if GetGuildInfo("player") == "Extrema Ratio" then
		local msg  = "Vuoi settare \|cFFFF0000Figolas\|r con le opzioni base per la gilda?\n"
		msg = format("%s%s",msg, db.timesAskedExtremaIni == 2 and "Se premi Cancel te lo chiederò anche la prossima volta per sicurezza." or "")
		msg = format("%s%s",msg, db.timesAskedExtremaIni == 3 and "Questa questa è l'ultima volta che te lo chiedo, prometto!" or "")
		ERA:AddAlert(msg,ERA.IniExtremaDB,this)
	else
		db.ExtremaIni = true; ERA.ExtremaIni = nil;
	end
end

--***************************************
--***************************************
function ERA:OnInitialize()
	  -- Code that you want to run when the addon is first loaded goes here.
	self.db = LibStub("AceDB-3.0"):New("ERADB", DEFAULTDB)
	db = self.db.profile
	self.db.RegisterCallback(self, "OnNewProfile", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileChanged", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileDeleted", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileCopied", "ManageProfile")
	self.db.RegisterCallback(self, "OnProfileReset", "ManageProfile")
<<<<<<< HEAD
	--db = DEFAULTDB.profile
	--self.db = db
=======

>>>>>>> 1.1
	self.msgBuffer = {}
	self.ranks = {}
	self.cachedRoster = {}
	self.invitiRichiesti = {} 
<<<<<<< HEAD
	self.imbucati = 0--conta gli imbucati
	self.totaldraft = 0
=======
	self.chatMsgActions = {}
	self.imbucati = 0--conta gli imbucati
	self.totaldraft = 0
	self.delay = 0.5 --ritardo con cui si eseguono i comandi, per evitare lockout
	self.monitorClass = "assistMonitor"
	ERA:KwordListToTable()--lista delle parole per il whisper
>>>>>>> 1.1
	
	--corregge errore su ini extrema
	if db.roster then 
		for k in pairs(db.roster) do
			db.raid.roster[k] = k
		end
		db.roster = nil 
	end
	
	ERA:AddAllEPGPBtnsToSlashCmd()--aggiunge i comandi creandoli dai pulsanti EPGP
	self:RegisterEvent("CHAT_MSG_SYSTEM") 
	self:RegisterEvent("GROUP_ROSTER_UPDATE")
	if db.whisper.safe then --su ini per prevenire gli inviti da whisper dopo un crash del RL
		self:RegisterEvent("ENCOUNTER_START")       
		self:RegisterEvent("ENCOUNTER_END")           
	end
	if db.promozione.tankAssist then
		self:RegisterEvent("ROLE_CHANGED_INFORM")  
		self:RegisterEvent("READY_CHECK")	
	end
	if db.whisper.alwaysOn or db.whisper.on then 
		self:SwitchWhisper(true)
	end		
	
	ERA.EPGP = _G.EPGP
--paranoico controllo per evitare casini: se manca anche solo una delle funzioni richieste allora non se ne fa nulla...
	if not (ERA.EPGP and ERA.EPGP.CanDecayEPGP and ERA.EPGP.CanIncEPBy and ERA.EPGP.DecayEPGP and ERA.EPGP.RecurringEPPeriodMinutes and ERA.EPGP.StartRecurringEP and ERA.EPGP.StopRecurringEP and ERA.EPGP.RunningRecurringEP) then
		ERA.EPGP = nil
	end
	ERA:EPGPBtnOptions()--lo inizializziamo cmq, perche' potrebbero esserci delle tabelle nelle opzioni da creare ma nascoste
	
<<<<<<< HEAD

=======
>>>>>>> 1.1
	--per chat_msg_system locale
	--local JOIN, ONLINE	
	ERA.JOIN = gsub(ERR_JOINED_GROUP_S, "%%s", "(%%S+)")
	--ONLINE = gsub(ERR_FRIEND_ONLINE_SS, "%%s", "")--ERR_FRIEND_ONLINE_SS
	--ERA:AddToChatMsgActions("JOIN", ERR_JOINED_GROUP_S)
	
	
end

function ERA:OnEnable()	
    -- Called when the addon is enabled	
	self:UpdateGuildRoster()
	if IsInGuild() then 
		for i = 1, GuildControlGetNumRanks() do		
			self.ranks[i] = GuildControlGetRankName(i)
		end
	else
		self.ranks[1] = L["Non in una gilda"]
	end
	self.maxLvl = GetMaxPlayerLevel()
	self.PGRealm = gsub(GetRealmName(),"%s","") 	
	self:IniOptions()	
	ERA:AddBlizOpt()
	 
	ERA.ExtremaIni = not db.ExtremaIni
			
	self.checkPromozioni = true
	if not ERA:Gettutorial("assistMonitor") then
		ERA:AddAlert(format('\|cFFFF0000FIGOLAS\|r\n\|cFFFFFF00%s "\|cFFFF0000%s|r\|cFFFFFF00" %s.|r',L["Ora puoi controllare chi sta targettando i bersagli corretti, abilitando i monitor per il target e per il focus.\nPremi"], L["OK"],L["per le opzioni"]), ERA.DialogBoxOpenToTab, this, "assistMonitor")
		ERA:Settutorial("assistMonitor", true)
	end	
	ERA:RegisterEvent("PLAYER_REGEN_DISABLED")
end

function ERA:OnDisable()
    -- Called when the addon is disabled
end

function ERA:ManageProfile(event, DB, prof)
	db = self.db.profile	
	ERA:KwordListToTable()--lista delle parole per il whisper
	wipe(self.options)
	ERA:DelAllEPGPBtnsCmd()
	ERA:AddAllEPGPBtnsToSlashCmd()
	self:IniOptions()
	ERA:CreateMonitorUI()
	ERA:AggiornaMonitor()
end

--[[***************************************

SLASH COMMAND

******************************************]]
ERA.Com = {
	i = {
		desc=L["Invita tutti i confermati."],
		actn = function() ERA:MassInvite() end,	
	},
	w = {
		desc=L["Attiva/disattiva gli inviti con whisper."],
		actn = function() ERA:SwitchWhisper() end,	
	},
	m = {
		desc=L["Mostra il monitor degli inviti."],
		actn = function() if ERA.Monitor and ERA.Monitor:IsShown() then
				ERA.Monitor:Hide()
			else
				ERA:ShowMonitor()
			end 
		end,	
	},
	pro = {
		desc= function() return format(L["Promuove i membri del raid al grado %s"], db.promozione.upName and db.promozione.upName or L["scelto"])end,
		actn = function() if ERA:CanPromote() then ERA:PromuoviGilda() end end,	
	},
	de = {
		desc= function() return format(L["Degrada dal grado %s al grado %s"], db.promozione.upName and db.promozione.upName or L["scelto"], db.promozione.downName and db.promozione.downName or L["precedente"])end,
		actn = function() if ERA:CanDemote() then ERA:DegradaGilda() end end,	
	},
}

function ERA:Help()
	local msg = ""
	print(L["\|cFFFF0000FIGOLAS\|r Lista comandi\n"])
	for k, v in pairsByKeys(ERA.Com) do
		msg = format("\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r", k, type(v.desc) == "function" and v.desc() or v.desc)
		print(msg)
	end
end

function ERA:HelpOptions1()
	local df = {
		order = 100,
		type= "description",
		name = "test",
		fontSize = "medium",
	}
	local des = {}
	local msg, i = "", 0
	for k, v in pairsByKeys(ERA.Com) do		
		if not des[k] then des[k] = setmetatable({},{__index = df}) end
		des[k].name = function () return format("\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r\n", k, type(v.desc) == "function" and v.desc() or v.desc) end
		des[k].order = 100+i
		i = i+1
	end
	return des
end

function ERA:AddEPGPBtnToSlashCmd(btn)
	
	local cmd = match(db.opzioni.EPGPUICfg[btn].txt, "(%S+)"),""
	if not cmd then return end
	cmd = lower(cmd)
	local wcmd = cmd
	local i = 1
	while ERA.Com[wcmd] do
		wcmd = cmd..i
		i = i + 1		
		if i >100 then break end
	end
	ERA.Com[wcmd] = {
		desc = function() return ERA:EPGPBtnDesc(btn) end,
		actn = function() if ERA:CanClickEPGPBtn(btn) then ERA:ClickEPGPBtn(btn) end end,	
		ref = btn
	}
end

function ERA:DelEPGPBtnFromSlashCmd(btn)
	for k, v in pairs(ERA.Com) do
		if v.ref and v.ref == btn then
			ERA.Com[k] = nil
			break
		end
	end
end

function ERA:DelAllEPGPBtnsCmd()
	for k, v in pairs(ERA.Com) do
		if v.ref then 
			ERA.Com[k] = nil
		end
	end
end

function ERA:AddAllEPGPBtnsToSlashCmd()
	for btn in pairs(db.opzioni.EPGPUICfg) do
		ERA:AddEPGPBtnToSlashCmd(btn)
	end
end

function ERA:SlashCommand(msg)
	if not msg or msg =="" then
	--/era senza altro dietro apre il pannello delle opzioni
		LibStub("AceConfigDialog-3.0"):Open(addonName)	
		return
	end
	local op, other = match(msg,"(%S+)")--estrae l'argomento
	if op and ERA.Com[op] then ERA.Com[op].actn() else ERA:Help() end
end

SLASH_FIGOLAS1 ="/era"
SLASH_FIGOLAS2 ="/figolas"
SLASH_FIGOLAS3 ="/fig"
function SlashCmdList.FIGOLAS(msg)
	ERA:SlashCommand(msg)
end